#include "raven_spn.h"
#include "spn_regs.h"
#include "init.h"
#include "spn_checker_regs.h"

using spn = spn_regs<0x90000000>;
using spn_checker = spn_checker_regs<0x10040000>;

// huge arrays of XSPN input and referance data
extern std::array<uint8_t, 50000> input_data;
extern std::array<double, 10000> ref_data;

void run_xspn(int in_addr, int out_addr, int num_samples, int in_beats, int out_beats) {
    spn::mode_reg() = 0;
    spn::input_length_reg() = num_samples;      // each sample consists of 5 uint8 values
    spn::input_addr_reg() = in_addr;
    spn::output_addr_reg() = out_addr;
    spn::num_of_in_beats_reg() = in_beats;  // Number of AXI4 burst beats needed to load all input data
    spn::num_of_out_beats_reg() = out_beats;    // Number of AXI4 burst beats needed to store all result data
    printf("Starting XSPN\n");
    spn::start_reg() = 1;
}


/*! \brief main function
 *
 */
int main() {


    platform_init();

    spn::mode_reg() = 1;
    spn::start_reg() = 1;
    wait_for_interrupt();
    spn::interrupt_reg() = 1;
    uint32_t readout = spn::readout_reg();
    printf("READOUT HW:0x%x\n", readout);

    uint32_t axi_bytes = readout;
    axi_bytes = axi_bytes & 0xff;
    axi_bytes = 1 << axi_bytes;

    printf("AXI Bytes: %d\n", axi_bytes);

    uint32_t sample_bytes = readout;
    sample_bytes = sample_bytes >> 16;
    sample_bytes = sample_bytes / 8;

    printf("Sample Bytes: %d\n", sample_bytes);

    uint32_t result_bytes = 8;

    printf("Result Bytes: %d\n", result_bytes);

    uint32_t step = 2000;
    uint32_t iterations = 5;
    
    uint32_t in_beats = (step * sample_bytes) / axi_bytes;
    if (in_beats * axi_bytes < step * sample_bytes) in_beats++;
    uint32_t out_beats = (step * result_bytes) / axi_bytes;
    if (out_beats * axi_bytes < step * result_bytes) out_beats++;

    int in_addr  = (int)input_data.data();
    int out_addr = 0x800B0000;

    spn_checker::ref_addr_reg() = (int)ref_data.data();
    spn_checker::addr_reg() = out_addr;

    for (int k = 0; k < iterations*step; k+=step) {
        run_xspn(in_addr, out_addr, step, in_beats, out_beats);
        wait_for_interrupt();
        printf("XSPN finished\n");
        spn_checker::offset_reg() = k;
        spn_checker::length_reg() = step;
        spn_checker::start_reg() = 1;
        spn::interrupt_reg() = 1;

        in_addr += step * sample_bytes; // 5 bytes in each sample
    }

    return 0;
}
